unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs, Gauges;

type
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText10: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditBoundR1: TEdit;
    EditBoundR2: TEdit;
    EditBoundS1: TEdit;
    EditBoundS2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    EditRovX: TEdit;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    EditAlfaView: TEdit;
    EditBetaView: TEdit;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    EditAlfaLight: TEdit;
    EditBetaLight: TEdit;
    StaticText19: TStaticText;
    EditSegm: TEdit;
    StaticText22: TStaticText;
    EditRovY: TEdit;
    EditRovZ: TEdit;
    StaticText23: TStaticText;
    StaticText24: TStaticText;
    EditD: TEdit;
    StaticText25: TStaticText;
    StaticText26: TStaticText;
    RightImage: TImage;
    WrongImage: TImage;
    Button1: TButton;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    Gauge1: TGauge;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);
    procedure SetRightColor(Sender: TObject);
    procedure SetWrongColor(Sender: TObject);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph3d_2005;

{$R *.DFM}

Type TSegment = record
                 A,B,C,D:T3DPoint;
                 v:Single;
                end;
var BackRed,BackGreen,BackBlue,
    RightRed,RightGreen,RightBlue,
    WrongRed,WrongGreen,WrongBlue:Byte;
    RedSegm,GreenSegm,BlueSegm   :Byte;
    RedShadow,GreenShadow,BlueShadow:Byte;
    NoOfSegments,CountOfSegments  :Longint;
    Segment                      :array [0..200000] of TSegment;
    Stin                         :array[0..510,0..360] of byte;
    Express_fx,
    Express_fy,
    Express_fz  :TExpression;

procedure TControl_Panel.Plocha(Sender: TObject);
var Code,i,j,Drsnost:LongInt;
    LightDistance,View,Light    :Double;
    f,ErrorReport:String;
    A,B,C,D,LightSource    :T3DPoint;
    Rub                :Boolean;
    DirectOfLight,u,v,w:TVector;
    fx,fy,fz           :string;

  Procedure Setting;
  var numer:Real;
  begin
    Val(EditX1.Text,Numer,Code);Draw3D.X1:=Numer;
    Val(EditX2.Text,Numer,Code);Draw3D.X2:=Numer;
    Val(EditY1.Text,Numer,Code);Draw3D.Y1:=Numer;
    Val(EditY2.Text,Numer,Code);Draw3D.Y2:=Numer;
    Val(EditBoundR1.Text,Numer,Code);Draw3D.R1:=Numer;
    Val(EditBoundR2.Text,Numer,Code);Draw3D.R2:=Numer;
    Val(EditBoundS1.Text,Numer,Code);Draw3D.S1:=Numer;
    Val(EditBoundS2.Text,Numer,Code);Draw3D.S2:=Numer;
    Val(EditAlfaView.Text,Draw3D.AlfaView,Code);
    Val(EditBetaView.Text,Draw3D.BetaView,Code);
    Val(EditD.Text,Draw3D.ObserverDistance,Code);
    fx:=EditRovX.Text;
    fy:=EditRovY.Text;
    fz:=EditRovZ.Text;
    Val(EditAlfaLight.Text,Draw3D.AlfaLight,Code);
    Val(EditBetaLight.Text,Draw3D.BetaLight,Code);
    LightDistance:=30;
    Val(EditSegm.Text,CountOfSegments,Code);
  end;  {Setting}

Procedure PointShadow(M:T3DPoint;var pM:T3DPoint);
var Sm:TVector;
    XX:T3DPoint;
begin
 With Draw3D do
 begin
  t:=-(LightSource[3]+4)/(M[3]-LightSource[3]);
  XX[1]:=LightSource[1]+(M[1]-LightSource[1])*t;
  XX[2]:=LightSource[2]+(M[2]-LightSource[2])*t;
  XX[3]:=-4;
  Sm:=MajorRay;
  t:=-Sm[1]*ObserverPoint[1]-Sm[2]*ObserverPoint[2]-Sm[3]*ObserverPoint[3];
  t:=t/(Sm[1]*(XX[1]-ObserverPoint[1])+Sm[2]*(XX[2]-ObserverPoint[2])+Sm[3]*(XX[3]-ObserverPoint[3]));
  pM[1]:=ObserverPoint[1]+(XX[1] -ObserverPoint[1])*t;
  pM[2]:=ObserverPoint[2]+(XX[2]-ObserverPoint[2])*t;
  pM[3]:=ObserverPoint[3]+(XX[3]-ObserverPoint[3])*t;
 end;
end;

  procedure sort(Left,Right:LongInt);
   var i,j      :LongInt;
       Pivot    :Double;
       Trezor   :TSegment;
   begin
     i:=Left;j:=Right;
     pivot:=Segment[(Left+Right) div 2].v;
     repeat
     while Segment[i].v<pivot do inc(i);
     while Segment[j].v>pivot do dec(j);
     if i<=j then
              begin
                Trezor:=Segment[i];Segment[i]:=Segment[j];Segment[j]:=Trezor;
                inc(i);dec(j);
              end;
   until i>j;
   if Left<j then sort(Left,j);
   if Right>i then sort(i,Right);
   end;

  Procedure ConstructOfShadow;
  const GreatOfSquare = 2;
  var Ap,Bp,Cp,Dp,XPoint:T3DPoint;
      Zp,Xc        :T2DPoint;
      Pixel        :TPixel;
      i,j,l,k,iRed,iGreen,iBlue,Citac :Integer;
      Pom                :Array[1..2] of Integer;
      MinX,MinY,MaxX,MaxY,Adr:Integer;
      SL                 :PByteArray;
      r,s,MinValue,Value,MaxValue,Suma,Level:Single;

  begin
     Draw3D.ClearImage(255,255,255);
     For i:=0 to NoOfSegments do
       begin
        With Segment[i] do
          begin PointShadow(A,Ap);PointShadow(B,Bp);PointShadow(C,Cp);PointShadow(D,Dp);end;
        Draw3D.FillTriangle(Ap,Bp,Cp,127,127,127);
        Draw3D.FillTriangle(Cp,Dp,Ap,127,127,127);
       end;

     MinX:=Draw3D.Image.Width;MaxX:=0;
     MinY:=Draw3D.Image.Height;MaxY:=0;
      For j:=1 to Draw3D.Image.Height-1 do
      begin
       SL:=Draw3D.Image.Picture.Bitmap.ScanLine[j];
       For i:=1 to Draw3D.Image.Width-1 do
          if (SL[3*i]<255)
            then begin
                   if i>MaxX then MaxX:=i else if i<MinX then MinX:=i;
                   if j>MaxY then MaxY:=j else if j<MinY then MinY:=j;
                 end;
       Gauge1.Progress:=35+Trunc(25*j/Draw3D.Image.Height);
      end;
     MinValue:=100;MaxValue:=-100;
     For j:=1 to Draw3D.Image.Height-1 do
      begin
       SL:=Draw3D.Image.Picture.Bitmap.ScanLine[j];
       For i:=1 to Draw3D.Image.Width-1 do
        begin
          Adr:=3*i;
          if (SL[Adr]<255)then
          begin
          Value:=1/pi*arctan(5*((i-(MaxX+MinX)/2)*sin(Draw3D.AlfaLight*pi/180)
                     +(j-(MaxY+MinY)/2)*cos(Draw3D.AlfaLight*pi/180))/((MaxX-MinX)+(MaxY-MinY)))+0.2;
          if MinValue>Value then MinVAlue:=Value
                            else if MaxValue<Value then MaxValue:=VAlue;
          if Value<0 then Value:=0 else if Value>1 then Value:=1;
          SL[Adr]:=Trunc(SL[Adr]*2*(1-Value));
         end;
        end;
        Gauge1.Progress:=60+Trunc(10*j/Draw3D.Image.Height);
      end;

      For j:=1 to Draw3D.Image.Height-2 do
      begin
        For i:=1 to Draw3D.Image.Width-2 do
        begin
         Suma:=0;
         for l:=j-1 to j+1 do
         begin
           SL:=Draw3D.Image.Picture.Bitmap.ScanLine[l];
           For k:=i-1 to i+1 do Suma:=Suma+SL[3*k];
         end;
         Stin[i,j]:=Round(Suma/9);
       end;
       Gauge1.Progress:=70+Trunc(25*j/Draw3D.Image.Height);
     end;
     With Draw3D do
     begin
     r1:=-10;r2:=10;s1:=-10;s2:=10;Level:=10;
     For j:=0 to Image.Height-1 do
       begin
         SL:=Image.Picture.Bitmap.Scanline[j];
         for i:=0 to Draw3D.Image.Width-1 do
                begin
                  Xc[1]:=InvXCoor(i);Xc[2]:=InvYCoor(j);
                  XPoint[1]:=Xc[1]*j2*MajorRay[3]+j1*k2+k1*Xc[2]*MajorRay[2]
                      -j2*k1-MajorRay[2]*k2*Xc[1]-MajorRay[3]*Xc[2]*j1;
                  XPoint[2]:=i1*Xc[2]*MajorRay[3]+Xc[1]*k2*MajorRay[1]+k1*i2
                       -MajorRay[1]*Xc[2]*k1-k2*i1-MajorRay[3]*i2*Xc[1];
                  XPoint[3]:=i1*j2+j1*Xc[2]*MajorRay[1]+Xc[1]*i2*MajorRay[2]
                       -MajorRay[1]*j2*Xc[1]-MajorRay[2]*Xc[2]*i1-i2*j1;
                  r:=(XPoint[1]*(ObserverPoint[3]-XPoint[3])+(ObserverPoint[1]-XPoint[1])*(Level-XPoint[3]))/(Level-XPoint[3]);
                  s:=(XPoint[2]*(ObserverPoint[3]-XPoint[3])+(ObserverPoint[2]-XPoint[2])*(Level-XPoint[3]))/(Level-XPoint[3]);
                  Pixel[1]:=Trunc(abs(100*(r-r1)/(r2-r1)));
                  Pixel[2]:=Trunc(abs(100*(s-s1)/(s2-s1))-GreatOfSquare/2);
                  if odd(Pixel[1] div GreatOfSquare) and not odd(Pixel[2] div GreatOfSquare)
                             then begin Red:=RightRed;Green:=RightGreen;Blue:=RightBlue end
                             else begin Red:=WrongRed;Green:=WrongGreen;Blue:=WrongBlue end;
                           Adr:=3*i;
                           SL[Adr]            :=Blue;
                           SL[succ(Adr)]      :=Green;
                           SL[succ(succ(Adr))]:=Red;
               end;
           Gauge1.Progress:=95+Trunc(5*j/Draw3D.Image.Height);
         end;
       Image.Repaint;
   end;
  Gauge1.Visible:=False;

     For j:=1 to Draw3D.Image.Height-1 do
      begin
       SL:=Draw3D.Image.Picture.Bitmap.ScanLine[j];
       For i:=1 to Draw3D.Image.Width-1 do
        begin
          Adr:=3*i;
          Value:=(i*sin(Draw3D.AlfaLight*pi/180)+j*cos(Draw3D.AlfaLight*pi/180))
                     /(Draw3D.Image.Width+Draw3D.Image.Height)+0.5;
          if Value<0 then Value:=0 else if Value>1 then Value:=1;
          SL[Adr]            :=Trunc(SL[Adr]*Value);
          SL[succ(Adr)]      :=Trunc(SL[succ(Adr)]*Value);
          SL[succ(succ(Adr))]:=Trunc(SL[succ(succ(Adr))]*Value);
        end;
      end;

    for i:=0 to Draw3D.Image.Width-1 do
    begin
       for j:=0  to Draw3D.Image.Height-1 do
       With Draw3D do
       begin
         Pixel[1]:=i;Pixel[2]:=j;
         GetPixel(Pixel,Red,Green,Blue);
         iRed:=Trunc(Stin[i,j]*Red/255);
         iGreen:=Trunc(Stin[i,j]*Green/255);
         iBlue:=Trunc(Stin[i,j]*Blue/255);
         PutPixel(Pixel,iRed,iGreen,iBlue);
       end;
     if i mod 100 = 0 then begin
                            Draw3D.Image.Repaint;
                            Application.ProcessMessages;
                           end;
    end;
    Draw3D.Image.Repaint;
  end;

  begin
    Gauge1.Progress:=0;
    Gauge1.Visible:=True;
    Setting;
    With Draw3D do
    begin
       ClearImage(255,255,255);
       Visible:=True;
       Scale(x1,x2,y1,y2);
       SetCenterProjection(AlfaView,BetaView,ObserverDistance,ObserverPoint);
       AlfaLight:=pi*AlfaLight/180;BetaLight:=pi*BetaLight/180;
       DirectOfLight[1]:=cos(AlfaLight)*cos(BetaLight);
       DirectOfLight[2]:=sin(AlfaLight)*cos(BetaLight);
       DirectOfLight[3]:=sin(BetaLight);
       LightSource[1]:=LightDistance*DirectOfLight[1];
       LightSource[2]:=LightDistance*DirectOfLight[2];
       LightSource[3]:=LightDistance*DirectOfLight[3];
   end;
   With Draw3D do
    begin
    hr:=(r2-r1)/CountOfSegments;
    hs:=(s2-s1)/CountOfSegments;
    Express_fx:=PreCalc(fx,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fy:=PreCalc(fy,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fz:=PreCalc(fz,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    r:=r1;NoOfSegments:=0;
    Repeat
      s:=s1;
      Repeat
         Segment[NoOfSegments].A[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].A[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].A[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].v:=sqr(Draw3D.ObserverPoint[1]-Segment[NoOfSegments].A[1])
                         +sqr(Draw3D.ObserverPoint[2]-Segment[NoOfSegments].A[2])
                         +sqr(Draw3D.ObserverPoint[3]-Segment[NoOfSegments].A[3]);
         s:=s+hs;
         Segment[NoOfSegments].B[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].B[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].B[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         r:=r+hr;
         Segment[NoOfSegments].C[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].C[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].C[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         s:=s-hs;
         Segment[NoOfSegments].D[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].D[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegments].D[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         inc(NoOfSegments);
         r:=r-hr;
         s:=s+hs;
       until s>s2;
      r:=r+hr;
    until r>r2;
    ConstructOfShadow;
    Sort(0,NoOfSegments);
   For i:=NoOfSegments downto 0 do
     begin
       SetVector(Segment[i].B,Segment[i].C,u);
       SetVector(Segment[i].B,Segment[i].A,v);
       VectorProduct(u,v,w);
       SetVector(Segment[i].B,ObserverPoint,u);
       View:=CosAngle(u,w);
       if View>0 then Rub:=True else Rub:=False;
       Light:=CosAngle(w,DirectOfLight);
       if Rub then begin
                    Red:=Trunc(abs(Light*RightRed));Green:=Trunc(abs(Light*RightGreen));Blue:=Trunc(abs(Light*RightBlue));
                   end
              else begin
                    Red:=Trunc(abs(Light*WrongRed));Green:=Trunc(abs(Light*WrongGreen));Blue:=Trunc(abs(Light*WrongBlue));
                   end;
       if View*Light<0 then begin Red:=0;Green:=0;Blue:=0;end;
       FillTriangle(Segment[i].A,Segment[i].B,Segment[i].C,Red,Green,Blue);
       FillTriangle(Segment[i].C,Segment[i].D,Segment[i].A,Red,Green,Blue);
       if i mod 100 = 0 then Image.Repaint;
    end;
  end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;

procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Real;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;


procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
  Application.CreateForm(TDraw3D, Draw3D);
  With Draw3D do
  begin
    ClientWidth:=500;ClientHeight:=350;
    With Panel do begin
                    align:=alNone;
                    Width:=505;Height:=355;
                    Left:=-2;Top:=-2;
                  end;
    With Image do begin Left:=-2;Top:=-2;end;
    InitImage(505,355);
    Left:=410;Top:=30;
    Caption:='Overshadowed Object';
    AutoScroll:=False;
    Visible:=True;
  end;
  RightBlue:=255;
  RightGreen:=200;
  RightRed:=200;
     With RightImage.Canvas do
     begin
       Pen.Color  :=RightRed+256*RightGreen+256*256*RightBlue;
       Brush.Color:=Pen.Color;
       Rectangle(0,0,Width,Height);
     end;
  WrongBlue:=200;
  WrongGreen:=255;
  WrongRed:=255;
  With WrongImage.Canvas do
   begin
     Pen.Color  :=WrongRed+256*WrongGreen+256*256*WrongBlue;
     Brush.Color:=Pen.Color;
     Rectangle(0,0,Width,Height);
   end;
end;


procedure TControl_Panel.SetRightColor(Sender: TObject);
begin
  With ColorDialog1 do
  if Execute then
  begin
     RightBlue:=Color div (256*256);
     RightGreen:=(Color-256*256*RightBlue) div 256;
     RightRed:=Color-256*256*RightBlue-256*RightGreen;
     With RightImage.Canvas do
     begin
       Pen.Color  :=Color;
       Brush.Color:=Color;
       Rectangle(0,0,Width,Height);
     end;
  end;
end;

procedure TControl_Panel.SetWrongColor(Sender: TObject);
begin
  With ColorDialog1 do
  if Execute then
  begin
     WrongBlue:=Color div (256*256);
     WrongGreen:=(Color-256*256*WrongBlue) div 256;
     WrongRed:=Color-256*256*WrongBlue-256*WrongGreen;
     With WrongImage.Canvas do
     begin
       Pen.Color  :=Color;
       Brush.Color:=Color;
       Rectangle(0,0,Width,Height);
     end;
  end;
end;

end.
